<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Http\Helper\Helper;
use App\Validators\BannerValidator;
use Illuminate\Support\Facades\Hash;
use App\Managers\Banner\BannerManager;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Session;
use App\Managers\User\UserManager;
use App\Managers\Proposal\ProposalManager;
use App\Validators\ProposalValidator;
use App\Managers\ProposalLikeCount\ProposalLikeCountManager;
use App\Managers\Decision\DecisionManager;
use App\Validators\DecisionValidator;
use App\Managers\DecisionProposalLikeCount\DecisionProposalLikeCountManager;
use App\Managers\PlayerRatings\PlayerRatingsManager;
use App\Validators\TacticsValidator;
use App\Managers\Tactics\TacticsManager;
use App\Managers\TacticSuggestions\TacticSuggestionsManager;
use App\Validators\TacticSuggestionValidator;
use App\Managers\TacticSuggestionsLikeCount\TacticSuggestionLikeCountManager;
use App\Managers\FormationPositions\FormationPositionsManager;
use App\Managers\TacticContainer\TacticContainerManager;
use App\Managers\PlayerRatingsVotes\PlayerRatingsVotesManager;
use App\Managers\PaymentID\PaymentIDManager;
//use App\Managers\SchedulePreMatchFormation\SchedulePreMatchFormationManager;
use App\Managers\Schedule\ScheduleManager;
use Illuminate\Support\Facades\Log;
use App\Managers\Paypal\PaypalManager;
use App\Managers\PlayerPositions\PlayerPositionsManager;
use App\Jobs\DecisionProposalEmail;
use App\Jobs\TacticSuggestionsEmail;
use App\Jobs\PlayerProposalEmail;

class MainApiController extends Controller
{
    public function __construct()
    {
        $this->helper = new Helper();
        $this->bannerValidator = new BannerValidator();
        $this->bannerManager = new BannerManager();
        $this->userManager = new UserManager();
        $this->proposalManager = new ProposalManager();
        $this->proposalValidator = new ProposalValidator();
        $this->proposalLikeCount = new ProposalLikeCountManager();
        $this->decisionManager = new DecisionManager();
        $this->decisionValidator = new DecisionValidator();
        $this->decisionProposalLikeCount = new DecisionProposalLikeCountManager();
        $this->playerRatingsManager = new PlayerRatingsManager();
        $this->tacticsValidator = new TacticsValidator();
        $this->tacticsManager = new TacticsManager();
        $this->tacticSuggestionManager = new TacticSuggestionsManager();
        $this->tacticSuggestionValidator = new TacticSuggestionValidator();
        $this->tacticSugestionsLikeCountManager = new TacticSuggestionLikeCountManager();
        $this->schedule = new ScheduleManager();
        $this->formationPosition = new FormationPositionsManager();
        $this->tacticContainer = new TacticContainerManager();
        $this->paypal = new PaypalManager();
        $this->playerRatingsVote = new PlayerRatingsVotesManager();
        $this->profile = new \App\Managers\Profile\ProfileManager();
        $this->profileInfo = $this->profile->first();
        $this->playerPositionsManager = new PlayerPositionsManager();
        $this->paymentIDManager = new PaymentIDManager();

        //$this->schedulePreMatchFormation = new SchedulePreMatchFormationManager();
    }
    
    public function submitBanner(Request $request)
    {
        if(!$request->all())
        {
            return response()->json(['No input found'], 400);
        }
//        
//        $totalUserVotes = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'));
//        
//        if($totalUserVotes->total < 5)
//        {
//            return response()->json(['You should have atleast 5 votes to submit banner'], 403);
//            exit;
//        }
        $bannersCount = $this->bannerManager->orderBy('created_at', 'DESC')->whereNull('paypal_id')->where('user_id', $request->session()->get('general'))->count();
        if($bannersCount > 0)
        {
            return response()->json(array('You uploaded a banner already'), 403);
        }
        $photo = $request->file('banner');
        $validation = $this->bannerValidator->add($photo, $request->get('url'));
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
        $imageName = rand(1000000,9999999) . date('dmYHis') . '.' . $request->file('banner')->getClientOriginalExtension();
        $request->file('banner')->move(base_path() . "/public/uploads/banner/", $imageName);
        $data['banner_location'] = url('/') . '/uploads/banner/' . $imageName;
        $data['UUID'] = $this->helper->addUuid();
        $data['ip'] = $_SERVER['REMOTE_ADDR'];
        $data['url'] = $request->get('url');
        //$data['expiry_date'] = date('Y-m-d',(strtotime ( '+30 day') ));
        $res = $this->bannerManager->add($data);
        if(!$res)
        {
            return response()->json(['Something went wrong'], 400);
        }
        
        return response()->json(['Banner Uploaded SUccefully'], 200);
    }
    
    public function member()
    {
        echo $this->userManager->becomeMember(Session::get('general'));
    }
    
    public function allBanners()
    {
        $currentData = date('Y-m-d');
        //$updatedDate = date('Y-m-d',(strtotime ( '-30 day') ));
        $banners = $this->bannerManager->orderBy('created_at', 'DESC')->where('expiry_date','>', $currentData)->whereNotNull('paypal_id')->get();
        return response()->json($banners,200);
    }
    
    public function allPendingBanners(Request $request)
    {
        //$updatedDate = date('Y-m-d',(strtotime ( '-30 day') ));
        $banners = $this->bannerManager->orderBy('created_at', 'DESC')->whereNull('paypal_id')->where('user_id', $request->session()->get('general'))->get();
        return response()->json($banners,200);
    }
    
    public function updateAccount(Request $request)
    {
        if(!$request->get('data'))
        {
            return response()->json(['No input found'], 400);
        }
        $data = $request->get('data');
        $data['dob'] = date("Y-m-d", strtotime($data['dob']));
        
        $user = $this->userManager->updateData($data, Session::get('general'));
        if(!$user)
        {
            return response()->json(['Something went wrong'], 400);
        }
        return response()->json(['Account Updated'], 200);
    }
    
    public function addProposal(Request $request)
    {
        if(!$request->get('data'))
        {
            return response()->json(['No input found'], 400);
        }
        
        $data = $request->get('data');
        $validation = $this->proposalValidator->add($data, $this->profileInfo->player_proposal_expiry_days);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
        $data['user_id'] = Session::get('general');
        $data['UUID'] = $this->helper->addUuid();
        $data['expiry_date'] = date("Y-m-d",(strtotime('+' . $this->profileInfo->player_proposal_expiry_days . ' day' ,strtotime(date("Y-m-d")))));
        $proposal = $this->proposalManager->add($data);
        if(!$proposal)
        {
            return response()->json(['Something went wrong'], 400);
        }
        
        $users = $this->userManager->where('type','general')->where('active', 1)->get();
        dispatch(new PlayerProposalEmail($users));
        return response()->json(['Proposal Added'], 200);
    }
    
    public function allProposals(Request $request)
    {
        $res['votes'] = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'))['total'];
        $totalVotesOfAllUsers = $request->session()->get('total_votes');
        if(!is_numeric($totalVotesOfAllUsers))
        {
            $totalVotesOfAllUsers = 0;
        }

        $res['totalMaxAllowedVotes'] = ceil($totalVotesOfAllUsers * 30 / 100);
        $proposals = $this->proposalManager->with('user')->where('reject', 0)->where('expiry_date', '>=', date("Y-m-d"))->orderBy('created_at', 'DESC')->get();
        
        $count = 0;
        foreach($proposals AS $proposal)
        {
            $likeCounts = $this->proposalLikeCount->getTotalLikesByUser($proposal['UUID'], $request->session()->get('general'));
            $res['proposals'][$count] = $proposal;
            $res['proposals'][$count]['max_likes'] = $likeCounts->total_likes;
            $count++;
        }
        
        return response()->json($res,200);
    }
    
    public function likeProposal(Request $request)
    {
        if(!$request->get('noOfLikes') || !$request->get('id'))
        {
            return response()->json(['Something went wrong'], 400);
        }
        
        $noOfLikes = $request->get('noOfLikes');
        if(!isset($noOfLikes) || !is_numeric($noOfLikes) ||  $noOfLikes < 0)
        {
            return response()->json(['Please enter number of Votes.'], 400);
        }
        
        $id = $request->get('id');
        
        $totalUserVotes = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'));
        //$totalVotesSubmitted = $this->tacticContainer->getTotalVotesOfUser($data['schedule_id'], $request->session()->get('general'));
        $likeCounts = $this->proposalLikeCount->getTotalLikesByUser($id, $request->session()->get('general'));
        if(($totalUserVotes->total - $likeCounts['total_votes']) < $noOfLikes)
        {
            return response()->json(['You donot have enough votes to vote'], 403);
            exit;
        }
        
        $totalVotesOfAllUsers = $request->session()->get('total_votes');
        if(!is_numeric($totalVotesOfAllUsers))
        {
            $totalVotesOfAllUsers = 0;
        }
        
        if($totalVotesOfAllUsers < $noOfLikes)
        {
            return response()->json(['You donot have enough votes to vote'], 403);
            exit;
        }
        
        
//        $schedule = $this->proposalLikeCount->where('user_id', $request->session()->get('general'))->where('proposal_id', $id)->first();
//        if($schedule)
//        {
//            return response()->json(['You had voted already'], 403);
//            exit;
//        }
        
        $validation = $this->proposalValidator->like($noOfLikes, $id);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
        
        $add = $this->proposalLikeCount->addLike($id, $noOfLikes);
        if(!$add)
        {
            return response()->json(['Something went wrong'], 400);
        }
        return response()->json(['Like Added Successfully'], 200);
    }
    
    public function currentProposalLike($proposalID)
    {
        $proposal = $this->proposalManager->where('UUID', $proposalID)->first();
        $res['votes'] = $this->paypal->getCurrentUserTotalVotesCount($proposal->user_id)['total'];
        
        $totalVotesOfAllUsers = $this->paypal->getTotalVotesCount();
        
        if(!is_numeric($totalVotesOfAllUsers))
        {
            $totalVotesOfAllUsers = 0;
        }

        $res['totalMaxAllowedVotes'] = ceil($totalVotesOfAllUsers * 30 / 100);
        $proposal = $this->proposalManager->where('UUID', $proposalID)->first();
        
        $likeCounts = $this->proposalLikeCount->getTotalLikesByUser($proposal->UUID, $proposal->user_id);
       // $res['proposals'] = $proposal;
        $res['max_likes'] = $likeCounts->total_likes;
        
        return response()->json($res,200);
    }
    
    public function likeTacticSuggestions(Request $request)
    {
        if(!$request->get('noOfLikes') || !$request->get('id'))
        {
            return response()->json(['Something went wrong'], 400);
        }
        $id = $request->get('id');
        
        $noOfLikes = $request->get('noOfLikes');
        $likeCounts = $this->tacticSugestionsLikeCountManager->getTotalLikesByUser($id, $request->session()->get('general'));
        $totalUserVotes = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'));
        
        if(($totalUserVotes->total - $likeCounts['total_likes']) < $noOfLikes)
        {
            return response()->json(['You donot have enough votes to vote'], 403);
            exit;
        }
        
        $totalVotesOfAllUsers = $request->session()->get('total_votes');
        if(!is_numeric($totalVotesOfAllUsers))
        {
            $totalVotesOfAllUsers = 0;
        }
        
        if($totalVotesOfAllUsers < $noOfLikes)
        {
            return response()->json(['You donot have enough votes to vote'], 403);
            exit;
        }
        
        $validation = $this->tacticSuggestionValidator->like($noOfLikes, $id);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
        
        $add = $this->tacticSugestionsLikeCountManager->addLike($id, $noOfLikes);
        if(!$add)
        {
            return response()->json(['Something went wrong'], 400);
            exit;
        }
        return response()->json(['Succesfully supported'], 200);
    }
    
    public function allDecisionProposals(Request $request)
    {
        $res['votes'] = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'))['total'];
        //$likeCounts = $this->decisionProposalLikeCount->getTotalLikesByUser($request->session()->get('general'));
        $proposals = $this->decisionManager->with('likes')->where('reject', 0)->orderBy('created_at', 'DESC')->get();
        
        $count = 0;
        foreach($proposals AS $proposal)
        {
            $likeCounts = $this->decisionProposalLikeCount->getTotalLikesByUser1($proposal['UUID'], $request->session()->get('general'));
            $res['proposals'][$count] = $proposal;
            $res['proposals'][$count]['max_likes'] = $likeCounts->total_likes;
            $count++;
        }
        
        return response()->json($res,200);
    }
    
    public function allActiveDecisionProposals(Request $request)
    {
        $res['votes'] = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'))['total'];
        $totalVotesOfAllUsers = $request->session()->get('total_votes');
        if(!is_numeric($totalVotesOfAllUsers))
        {
            $totalVotesOfAllUsers = 0;
        }

        $res['totalMaxAllowedVotes'] = ceil($totalVotesOfAllUsers * 30 / 100);
//        if($res['votes'] > $totalMaxAllowedVotes)
//        {
//            $res['votes'] = $totalMaxAllowedVotes;
//        }
        //$likeCounts = $this->decisionProposalLikeCount->getTotalLikesByUser($request->session()->get('general'));
        $proposals = $this->decisionManager->with('likes', 'user')->where('reject', 0)->where('expiry_date', '>=', date("Y-m-d"))->orderBy('created_at', 'DESC')->get();
        
        $count = 0;
        foreach($proposals AS $proposal)
        {
            $likeCounts = $this->decisionProposalLikeCount->getTotalLikesByUser1($proposal['UUID'], $request->session()->get('general'));
            $res['proposals'][$count] = $proposal;
            $res['proposals'][$count]['max_likes'] = $likeCounts->total_likes;
            $count++;
        }
        
        return response()->json($res,200);
    }
    
    public function addDecisionProposal(Request $request)
    {
        if(!$request->get('data'))
        {
            return response()->json(['No input found'], 400);
        }
        
        $data = $request->get('data');
       
        $validation = $this->decisionValidator->add($data, $this->profileInfo->decision_proposal_expiry_days);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
        $data['user_id'] = Session::get('general');
        $data['UUID'] = $this->helper->addUuid();
        $data['expiry_date'] = date("Y-m-d",(strtotime('+' . $this->profileInfo->decision_proposal_expiry_days . ' day' ,strtotime(date("Y-m-d")))));
        $proposal = $this->decisionManager->add($data);
        if(!$proposal)
        {
            return response()->json(['Something went wrong'], 400);
        }
        
        $users = $this->userManager->where('type','general')->where('active', 1)->get();
        dispatch(new DecisionProposalEmail($users));
        return response()->json(['Decision Proposal Added'], 200);
    }
    
    public function addTacticSuggestions(Request $request)
    {
        if(!$request->get('data'))
        {
            return response()->json(['No input found'], 400);
        }
        
        $data = $request->get('data');
        
        $validation = $this->tacticSuggestionValidator->add($data,  $this->profileInfo->tactics_proposal_expiry_days);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
        $data['user_id'] = Session::get('general');
        $data['UUID'] = $this->helper->addUuid();
        $data['expiry_date'] = date("Y-m-d",(strtotime('+' . $this->profileInfo->tactics_proposal_expiry_days . ' day' ,strtotime(date("Y-m-d")))));
        $proposal = $this->tacticSuggestionManager->add($data);
        if(!$proposal)
        {
            return response()->json(['Something went wrong'], 400);
        }
        
        $users = $this->userManager->where('type','general')->where('active', 1)->get();
        dispatch(new TacticSuggestionsEmail($users));
        return response()->json(['Decision Proposal Added'], 200);
    }
    
    public function likeDecisionProposal(Request $request)
    {
        if(!$request->get('noOfLikes') || !$request->get('id'))
        {
            return response()->json(['Something went wrong'], 400);
        }
        
        $id = $request->get('id');
        $noOfLikes = $request->get('noOfLikes');
        $createdAt = date("Y-m-d H:i",(strtotime ('-' . $this->profileInfo->decision_proposal_expiry_days . ' day' ,strtotime(date("Y-m-d")))));
        $decision = $this->decisionManager->where('UUID', $id)->first();
        if($createdAt > $decision['expiry_date'])
        {
            return response()->json(['This Descision is Expired'], 403);
            exit;
        }
        
        $likeCounts = $this->decisionProposalLikeCount->getTotalLikesByUser1($id, $request->session()->get('general'));
        
        
        
        
        $totalVotesOfAllUsers = $request->session()->get('total_votes');
        if(!is_numeric($totalVotesOfAllUsers))
        {
            $totalVotesOfAllUsers = 0;
        }

        $totalMaxAllowedVotes = ceil($totalVotesOfAllUsers * 30 / 100);
        if($noOfLikes > $totalMaxAllowedVotes)
        {
            return response()->json(['You donot have enough votes to vote'], 403);
            exit;
        }
        
        $totalUserVotes = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'));
        if(($totalMaxAllowedVotes - $likeCounts['total_likes']) < $noOfLikes)
        {
            return response()->json(['You donot have enough votes to vote'], 403);
            exit;
        }
           
        
        $validation = $this->decisionValidator->like($noOfLikes, $id);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
       
        $add = $this->decisionProposalLikeCount->addLike($id, $noOfLikes, $request->session()->get('general'));
        if(!$add)
        {
            return response()->json(['Something went wrong'], 400);
        }
        return response()->json(['Succesfully support'], 200);
    }
    
    public function savePlayerRatings(Request $request)
    {
        if(!$request->exists('columns') || !$request->exists('scheduleID'))
        {
            return response()->json(['Something went wrong'], 400);
        }
        $columns = $request->get('columns');
        $data = $request->get('data');
        $scheduleID = $request->get('scheduleID');
        
        if(!isset($data['no_of_votes']) || !is_numeric($data['no_of_votes']))
        {
            return response()->json(['Please enter number of votes in numeric format'], 500);
            exit;
        }
        
        $noOfLikes = $data['no_of_votes'];
        $totalUserVotes = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'));
        $ratings = $this->playerRatingsVote->getTotalVotesOfUser($scheduleID, Session::get('general'));
        if(($totalUserVotes->total - $ratings['total_rating']) < $noOfLikes)
        {
            return response()->json(['You donot have enough votes to vote'], 403);
            exit;
        }
        
        $validation = $this->playerRatingsManager->checkCurrentSchedule($columns, $data);
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
        $res = $this->playerRatingsManager->insertData($columns, $data, $scheduleID);
        if(!$res)
        {
            return response()->json(['Something went wrong'], 400);
        }
        return response()->json(['Rating Saved'], 200);
    }
    
    public function saveTactics(Request $request)
    {
        if(!$request->all() || !$request->exists('columns'))
        {
            return response()->json(['No Input Found.'], 400);
        }
        
        $columns = $request->get('columns');
        
        $data = $request->get('data');
        if(!isset($data['votes']) || !is_numeric($data['votes']) ||  $data['votes'] < 0)
        {
            return response()->json(['Please enter number of Votes.'], 400);
        }
        $noOfLikes = $votes = $data['votes'];
        $totalUserVotes = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'));
        $totalVotesSubmitted = $this->tacticContainer->getTotalVotesOfUser($data['schedule_id'], $request->session()->get('general'));
       
        $totalVotesOfAllUsers = $request->session()->get('total_votes');
        if(!is_numeric($totalVotesOfAllUsers))
        {
            $totalVotesOfAllUsers = 0;
        }
        
        if($totalVotesOfAllUsers < $noOfLikes)
        {
            return response()->json(['You donot have enough votes to vote'], 403);
            exit;
        }
        
        $totalMaxAllowedVotes = ceil($totalVotesOfAllUsers  * 30 / 100);
        if($noOfLikes > $totalMaxAllowedVotes)
        {
            return response()->json(['message' => 'You donot have enough votes to vote'], 403);
            exit;
        }
        
        if(($totalMaxAllowedVotes - $totalVotesSubmitted['total_votes']) < $noOfLikes)
        {
            return response()->json(['You donot have enough votes to vote'], 403);
            exit;
        }
        
        
//        $schedule = $this->tacticContainer->where('user_id', $request->session()->get('general'))->where('schedule_id', $data['schedule_id'])->first();
//        if($schedule)
//        {
//            return response()->json(['You had voted already'], 403);
//            exit;
//        }
        //unset($data['votes']);
        $validation = $this->tacticsValidator->addTactics($columns);
        
        if($validation)
        {
            return response()->json($validation['errors'], 400);
        }
        
        $schedulePlayers = $this->tacticsManager->add($columns, $data, $votes);
        if(!$schedulePlayers)
        {
            return response()->json(['Something went wrong'], 500);
        }
        
        return response()->json(['Tactics Added Successfully'], 200);
    }
    
    public function getLatestTactics(Request $request)
    {
        if(!$request->exists('positions'))
        {
            return response()->json([], 201);
        }
        if(!$request->exists('scheduleID'))
        {
            return response()->json(['Schedule ID not found'], 400);
        }
        
        $scheduleID = $request->get('scheduleID');
        $positions = $request->get('positions');
        $playerPoints = array();
        $playerPositions = array();
        $count1 = 0;
        
        $formation = $this->schedule->getCurrentMatchPreFormation($scheduleID);
      //  $formation = $this->schedule->getLatestMatchPreFormation($this->profileInfo->tactics_days_limit);
        $formationID = $formation->formation_id;
        
        $count2 = 0;
        foreach($positions AS $position => $count)
        {
            $playerPoint = $this->tacticsManager->getHighesValuePlayer($position, $count, $scheduleID);
            
            $count = 0;
            if($playerPoint->count() > 0)
            {
                $positionColumns = $this->formationPosition->getCurrentFormationPositionColumnOfPosition($playerPoint[0]->position_id, $formationID);
                $columnsArray = array();
                $playersArray = array();
                foreach($playerPoint AS $each1)
                {
                    
                    foreach($positionColumns AS $column)
                    {
                        if(!in_array($column->column_count, $columnsArray) && !in_array($each1->UUID, $playersArray))
                        {
                            $playerPositions[$count2]['UUID'] = $each1->UUID;
                            $playerPositions[$count2]['name'] = $each1->name;
                            $playerPositions[$count2]['photo'] = $each1->photo;
                            $playerPositions[$count2]['position_columns_id'] = $column->column_count;
                            $playerPositions[$count2]['votes'] = $this->tacticsManager->getCurrentTacticsPlayerVotes($each1->UUID, $scheduleID, $each1->position_id)->vote_count;
                            $columnsArray[] = $column->column_count;
                            $playersArray[] = $each1->UUID;
                                    
                            $count2++;
                        }
                    }
                    
//                    $playerPositions[$each1->position_id][$count]['name'] = $each1->name;
//                    $playerPositions[$each1->position_id][$count]['photo'] = $each1->photo;
//                    $playerPositions[$each1->position_id][$count]['position_columns_id'] = $each1->position_columns_id;
//                    
//                    $playerPositions[$each1->position_id][$count++]['votes'] = $each1->count;
                }
                
                
//                $playerPoints[$count1]['det'] = $playerPoint;
//                $playerPoints[$count1]['short_form'] = $playerPoint[0]['short_form'];
//                $playerPoints[$count1]['position_id'] = $playerPoint[0]['position_id'];
//                $count1++;
            }
        }
        
//        $response = array();
//        foreach($playerPoints AS $each)
//        {
//            $positionID = $each['position_id'];
//            $positionColumns = $this->formationPosition->getCurrentFormationPositionColumnOfPosition($positionID, $formationID);
//            
//            foreach($positionColumns AS $column)
//            {
//                $response[$positionID][$column->column_count]['column_count'] = $column->column_count;
//            }
//            
//        }
        
//        $count2 = 0;
//        foreach($playerPositions AS $key1 => $each2)
//        {
//            foreach($each2 AS $key2 => $value2)
//            {
//                if(isset($response[$key1]) && !isset($response1[$value2['position_columns_id']]['position_columns_id']))
//                {
//                    $response1[$count2]['name'] = $value2['name'];
//                    $response1[$count2]['photo'] = $value2['photo'];
//                    $response1[$count2]['position_columns_id'] = $value2['position_columns_id'];
//                    $response1[$count2++]['votes'] = $value2['votes'];
//                }
//               // $response1[$positionColumnID]['number_of_votes']
//            }
//            
//        }  
        $res = array();
        $res['response1'] = $playerPositions;
        $res['captainCount'] = $this->tacticContainer->getHighestVotedCaptain($scheduleID);
        $res['freekickCount'] = $this->tacticContainer->getHighestVotedFreeKick($scheduleID);
        
        $res['cornerCount'] = $this->tacticContainer->getHighestVotedCorner($scheduleID);
        $res['penaltyCount'] = $this->tacticContainer->getHighestVotedPenalty($scheduleID);
        
        $res['str1'] = $this->tacticContainer->getHighestVotedStr1($scheduleID);
        $res['str2'] = $this->tacticContainer->getHighestVotedStr2($scheduleID);
        
        return response()->json($res,200);
    }
    
    public function getEachTactics(Request $request)
    {
        if(!$request->exists('positions'))
        {
            return response()->json([], 201);
        }
        if(!$request->exists('scheduleID'))
        {
            return response()->json(['Schedule ID not found'], 400);
        }
        
        $scheduleID = $request->get('scheduleID');
        $positions = $request->get('positions');
        $playerPoints = array();
        $playerPositions = array();
        $count1 = 0;
        
        $formation = $this->schedule->where('UUID', $scheduleID)->first();
        $formationID = $formation->formation_id;
        
        $count2 = 0;
        foreach($positions AS $position => $count)
        {
            $playerPoint = $this->tacticsManager->getHighesValuePlayer($position, $count, $scheduleID);
            
            $count = 0;
            if($playerPoint->count() > 0)
            {
                $positionColumns = $this->formationPosition->getCurrentFormationPositionColumnOfPosition($playerPoint[0]->position_id, $formationID);
                $columnsArray = array();
                $playersArray = array();
                foreach($playerPoint AS $each1)
                {
                    
                    foreach($positionColumns AS $column)
                    {
                        if(!in_array($column->column_count, $columnsArray) && !in_array($each1->UUID, $playersArray))
                        {
                            $playerPositions[$count2]['UUID'] = $each1->UUID;
                            $playerPositions[$count2]['name'] = $each1->name;
                            $playerPositions[$count2]['photo'] = $each1->photo;
                            $playerPositions[$count2]['position_columns_id'] = $column->column_count;
                            $playerPositions[$count2]['votes'] = $this->tacticsManager->getCurrentTacticsPlayerVotes($each1->UUID, $scheduleID, $each1->position_id)->vote_count;
                            $columnsArray[] = $column->column_count;
                            $playersArray[] = $each1->UUID;
                                    
                            $count2++;
                        }
                    }
      
                }
 
            }
        }
        

        $res = array();
        $res['response1'] = $playerPositions;
        $res['captainCount'] = $this->tacticContainer->getHighestVotedCaptain($scheduleID);
        $res['freekickCount'] = $this->tacticContainer->getHighestVotedFreeKick($scheduleID);
        
        $res['cornerCount'] = $this->tacticContainer->getHighestVotedCorner($scheduleID);
        $res['penaltyCount'] = $this->tacticContainer->getHighestVotedPenalty($scheduleID);
        
        $res['str1'] = $this->tacticContainer->getHighestVotedStr1($scheduleID);
        $res['str2'] = $this->tacticContainer->getHighestVotedStr2($scheduleID);
        
        return response()->json($res,200);
    }
    
    public function allTacticSuggestions(Request $request)
    {
        $res['votes'] = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'))['total'];
        
        $tactics = $this->tacticSuggestionManager->with('likes')->where('reject', 0)->orderBy('created_at', 'DESC')->get();
        $count = 0;
        foreach($tactics AS $tactic)
        {
            $likeCounts = $this->tacticSugestionsLikeCountManager->getTotalLikesByUser($tactic['UUID'], $request->session()->get('general'));
            $res['tactics'][$count] = $tactic;
            $res['tactics'][$count]['max_likes'] = $likeCounts->total_likes;
            $count++;
        }
        
        return response()->json($res,200);
    }
    
    public function activeTacticSuggestions(Request $request)
    {
        $res['votes'] = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'))['total'];
        $totalVotesOfAllUsers = $request->session()->get('total_votes');
        if(!is_numeric($totalVotesOfAllUsers))
        {
            $totalVotesOfAllUsers = 0;
        }

        $totalMaxAllowedVotes = ceil($totalVotesOfAllUsers * 30 / 100);
        $res['totalMaxAllowedVotes'] = ceil($totalVotesOfAllUsers * 30 / 100);
        
        $tactics = $this->tacticSuggestionManager->with('likes', 'user')->where('reject', 0)->where('expiry_date', '>=', date('Y-m-d'))->orderBy('created_at', 'DESC')->get();
        
      
        $count = 0;
        foreach($tactics AS $tactic)
        {
            $likeCounts = $this->tacticSugestionsLikeCountManager->getTotalLikesByUser($tactic['UUID'], $request->session()->get('general'));
            $res['tactics'][$count] = $tactic;
            $res['tactics'][$count]['max_likes'] = $likeCounts->total_likes;
            $count++;
        }
        
        return response()->json($res,200);
    }
    
    public function getLatestMatchPreFormation()
    {
        $formation = $this->schedule->getLatestMatchPreFormation($this->profileInfo->tactics_days_limit);
        if($formation)
        {
            $scheduleID = $formation->UUID;
            $matchCount = $this->schedule->getCurrentMatchCount($scheduleID);
            $res['match_count'] = $matchCount[0]['match_number'];
            $schedule = $this->schedule->where('UUID', $scheduleID)->first();
            $res['name'] = $schedule->name;
        }
        $res['formation'] = $formation;
        
        if($formation)
        {
            return response()->json($res,200);
        }
        else
        {
            return response()->json(['days' => $this->profileInfo->tactics_days_limit],202);
        }
    }
    
    public function getLatestMatchPreFormationResults()
    {
        $formation = $this->schedule->getLatestMatchPreFormationWithoutLimit();
        if($formation)
        {
            $scheduleID = $formation->UUID;
            $matchCount = $this->schedule->getCurrentMatchCount($scheduleID);
            $res['match_count'] = $matchCount[0]['match_number'];
            $schedule = $this->schedule->where('UUID', $scheduleID)->first();
            $res['name'] = $schedule->name;
        }
        $res['formation'] = $formation;
        
        if($formation)
        {
            return response()->json($res,200);
        }
        else
        {
            return response()->json(['days' => $this->profileInfo->tactics_days_limit],202);
        }
    }
    
    public function getLatestMatchPreFormationResults1()
    {
        $formation = $this->schedule->getLatestMatchPreFormationWithoutLimit1();
        if(!$formation)
        {
            $formation = $this->schedule->getLatestMatchPreFormationWithoutLimit2();
        }
        if($formation)
        {
            $scheduleID = $formation->UUID;
            $matchCount = $this->schedule->getCurrentMatchCount($scheduleID);
            $res['match_count'] = $matchCount[0]['match_number'];
            $schedule = $this->schedule->where('UUID', $scheduleID)->first();
            $res['name'] = $schedule->name;
        }
        $res['formation'] = $formation;
        
        if($formation)
        {
            return response()->json($res,200);
        }
        else
        {
            return response()->json(['days' => $this->profileInfo->tactics_days_limit],202);
        }
    }
    
    public function getCurrentMatchPreFormationInfo($schedulID)
    {
        $formation = $this->schedule->getCurrentMatchPreFormation($schedulID);
        if($formation)
        {
            $scheduleID = $formation->UUID;
            $matchCount = $this->schedule->getCurrentMatchCount($scheduleID);
            $res['match_count'] = $matchCount[0]['match_number'];
            $schedule = $this->schedule->where('UUID', $scheduleID)->first();
            $res['name'] = $schedule->name;
        }
        $res['formation'] = $formation;
        
        if($formation)
        {
            return response()->json($res,200);
        }
        else
        {
            return response()->json(array(),204);
        }
    }
    
    public function getLatestPlayedMatchFormation()
    {
        $formation = $this->schedule->getLatestPlayedMatchFormation($this->profileInfo->player_evaluation_days_limit);
        $date = $formation->date_date;
        
       /* if(($date) < (date('Y-m-d', strtotime("-" . $this->profileInfo->player_evaluation_days_limit . " days"))))
        {
            return response()->json(array(),204);
        }*/
        if($formation)
        {
           
            return response()->json($formation,200);
        }
        else
        {
            return response()->json(array(),204);
        }
    }
    
    public function memberPaypal(Request $request, $userID)
    {
//        $memberPayment = $this->memberPayment->getCurrentMemberPayment($memberPaymentID);
//        if(!$memberPayment)
//        {
//            return redirect('/member/register/');
//        }
        
        
        $data = $request->all();
//        if($userID != $request->session()->get('general'))
//        {
//            $data['faulty'] = 1;
//        }
        $grossAmount = $data['payment_gross'];
        $data['no_of_votes'] = floor($grossAmount/100);
        $data['expiry_date'] = $end = date('Y-m-d', strtotime('+1 years'));
        $data['user_id'] = $userID;
        
//        $paypal = $this->paypalValidator->insertData($data);
//        if(!$paypal)
//        {
//            exit;
//        }
        $this->paypal->add($data);
    }
    
    
    public function getPlayerEvaluationRemainingVotes(Request $request, $scheduleID)
    {
        $votes = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'));
        $ratings = $this->playerRatingsVote->getTotalVotesOfUser($scheduleID, Session::get('general'));
        
        $totalVotesOfAllUsers = $request->session()->get('total_votes');
        if(!is_numeric($totalVotesOfAllUsers))
        {
            $totalVotesOfAllUsers = 0;
        }

        $totalMaxAllowedVotes = ceil($totalVotesOfAllUsers * 30 / 100);
        $totalMaxAllowedVotes = $totalMaxAllowedVotes - $ratings['total_votes'];
        
        $currentVotes = $votes['total'] - $ratings['total_votes'];
        
        if($totalMaxAllowedVotes < $currentVotes)
        {
            echo json_encode($totalMaxAllowedVotes, 200);
        }
        else
        {
            echo json_encode($currentVotes, 200);
        }
        
    }
    
    public function getRemainignVotesOnPlayerRatings(Request $request, $scheduleID)
    {
        $votes = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'));
        $ratings = $this->tacticContainer->getTotalVotesOfUser($scheduleID, Session::get('general'));
        
        
        
        $availableVotes = $votes['total'] - $ratings['total_votes'];
        $totalVotesOfAllUsers = $request->session()->get('total_votes');
        if(!is_numeric($totalVotesOfAllUsers))
        {
            $totalVotesOfAllUsers = 0;
        }

        $totalMaxAllowedVotes = ceil($totalVotesOfAllUsers  * 30 / 100);
        if($availableVotes > $totalMaxAllowedVotes)
        {
            $availableVotes = $totalMaxAllowedVotes;
        }
        
        $totalVotesSubmitted = $this->tacticContainer->getTotalVotesOfUser($scheduleID, $request->session()->get('general'));
        $availableVotes = $availableVotes - $totalVotesSubmitted['total_votes'];
        
        $count = 0;
//        foreach($ratings AS $rating)
//        {
//            print_r($rating);
//            exit;
//            $likeCounts = $this->tacticsManager->getTotalLikesByUser($rating['UUID'], $request->session()->get('general'));
//            
//            $res['tactics'][$count] = $rating;
//            $res['tactics'][$count]['max_likes'] = $likeCounts->total_likes;
//            $count++;
//        }
           
        echo json_encode($availableVotes, 200);
    }
    
    public function currentUserVotesCount(Request $request)
    {
        $votes = $this->paypal->getCurrentUserTotalVotesCount($request->session()->get('general'));
        echo $votes['total'];
    }
    
    public function deleteBanner($UUID)
    {
        $res = $this->bannerManager->where('UUID', $UUID)->delete();
        if(!$res)
        {
            echo json_encode(['Banner Deleted Successfully', 200]);
            exit;
        }
        echo json_encode(['Banner Deleted Successfully', 200]);
    }
    
    public function playerPositions($playerID)
    {
        $positions = $this->playerPositionsManager->select('position.*')->join('position', 'position.UUID', '=', 'player_positions.position_id')->where('player_positions.player_id', $playerID)->get();
        return response()->json($positions);
    }
    
    public function checkMobilPayOrder($orderID)
    {
        $res = $this->paymentIDManager->where('payment_id', $orderID)->where('payment_gateway', 'mobilpay')->first();
        if(!$res)
        {
            return response()->json(['status' => 0], 500);
            exit;
        }
        
        return response()->json(['status' => 1], 200);
        exit;
    }
}