<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\BannerContainer;
use App\Managers\BannerContainer\BannerContainerModel;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;
use App\Managers\Banner\BannerManager;
use App\Http\Helper\Helper;

class BannerContainerManager extends BannerContainerModel
{
    public function __construct()
    {
         
         $this->helper = new Helper();
    }

    public function insertData()
    {
        $this->banner = new BannerManager();
        $data['created_at'] = $data['updated_at'] = date("Y-m-d H:i:s");
        $userID = $data['user_id'] = Session::get('general');
        DB::beginTransaction();
        try 
        {
            $data['UUID'] = $this->helper->addUuid();
            $banner = $this->insert($data);
            if(!$banner)
            {
                return 0;
            }
            
            $updateData['banner_container_id'] = $data['UUID'];
            $update = $this->banner->whereNull('paypal_id')->where('user_id', $userID)->update($updateData);
            if(!$update)
            {
                return 0;
            }

            DB::commit();
            return $data['UUID'];
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function updateData($data, $UUID)
    {
        return $this->banner->where('UUID', $UUID)->update($data);
    }
}